{{

    Test Equipment File System

    }}
CON

  _dopin = 19
  _clkpin = 20
  _dipin = 21
  _cspin = 22
  _cdpin = -1 ' -1 if unused.
  _wppin = -1 ' -1 if unused.

  _rtcres1 = -1 ' -1 always.
  _rtcres2 = -1 ' -1 always.
  _rtcres3 = -1 ' -1 always.

  BufferSize = 128

obj

fat : "SD-MMC_FATEngine.spin"

var

        long    StrPtr
        byte    StrBufr[BufferSize]
        byte    BufferEnd

pub     Start

  fat.fatEngineStart( _dopin, _clkpin, _dipin, _cspin, _wppin, _cdpin, _rtcres1, _rtcres2, _rtcres3)
  BufferEnd := 0

pub NewString           'Clear the string buffer

        StrPtr := @StrBufr
        bytefill(@StrBufr,0,BufferSize)
        Return StrPtr

pub     AddString(str)  |StrLen, BufCap

        StrLen := STRSIZE (str)
        BufCap := BufferSize-STRSIZE(@StrBufr)
        if StrLen > BufCap
          return true
        bytemove(StrPtr,str,StrLen)
        StrPtr += (StrLen)
        return StrPtr

pub CopyString(str)

        bytemove(@StrBufr,str,STRSIZE(str))

pub Char(bte)

        byte[StrPtr++] := bte

pub Flush       |ErrStr, ErrNum

        fat.mountPartition(0)
  ErrStr := \fat.newFile(string("Inspect.csv"))
  ErrNum :=  fat.partitionError ' Returns zero if no error occurred.

  if(ErrNum) ' Try to handle the "entry_already_exist" error.
    if(ErrNum == fat#Entry_Already_Exist)

  fat.openFile(string("Inspect.csv"), "A")

  fat.writeString(@StrBufr)

  fat.unmountPartition

  NewString

pub AddInteger(value) | i, x

  x := value == NEGX                                                            'Check for max negative
  if value < 0
    value := ||(value+x)                                                        'If negative, make positive; adjust for max negative
    Char("-")                                                                   'and output sign

  i := 1_000_000_000                                                            'Initialize divisor

  repeat 10                                                                     'Loop for 10 digits
    if value => i
      Char(value / i + "0" + x*(i == 1))                                        'If non-zero digit, output digit; adjust for max negative
      value //= i                                                               'and digit from value
      result~~                                                                  'flag non-zero found
    elseif result or i == 1
      Char("0")                                                                 'If zero digit (or only digit) output it
    i /= 10                                                                     'Update divisor

pub StrBuf

        return @StrBufr